# kdecore Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KXErrorHandler Class Reference

This class simplifies handling of X errors. Handler for X errors. More...

`#include <kxerrorhandler.h>`

Collaboration diagram for KXErrorHandler:

[legend]
List of all members.

## Public Member Functions

| KXErrorHandler (Display *dpy=qt_xdisplay())
| KXErrorHandler (bool(*handler)(int request, int error_code, unsigned long resource_id), Display *dpy=qt_xdisplay())
| KXErrorHandler (int(*handler)(Display *, XErrorEvent *), Display *dpy=qt_xdisplay())
bool | error (bool sync) const

## Detailed Description

This class simplifies handling of X errors. Handler for X errors.

It shouldn't be necessary to use with Qt classes, as the toolkit should handle X errors itself, so this class will be mainly used with direct Xlib usage, and some lowlevel classes like NETWinInfo.

The usual usage is to create a KXErrorHandler instance right before starting operations that might cause X errors, and checking if there was an error by calling error() after the operations are finished. The handlers may be nested, but must be destroyed in reverse order they were created.

There's no need to do X sync before creating an instance, every instance will handle only errors for request issued after the instance was created. Errors for older requests will be passed to previous error handler. When checking for error by calling error() at the end, it is necessary to sync with X, to catch all errors that were caused by requests issued before the call to error(). This can be done by passing true to error() to cause explicit XSync(), however, if the last X request needed a roundtrip (e.g. XGetWindowAttributes(), XGetGeometry(), etc.), it is not required to do an explicit sync.

Author:
  Lubos Lunak <l.lunak@kde.org>

Definition at line 57 of file kxerrorhandler.h.

## Constructor & Destructor Documentation

KXErrorHandler::KXErrorHandler | ( | Display * | dpy = `qt_xdisplay()` | ) |

| Creates error handler that will set error flag after encountering any X error. Definition at line 36 of file kxerrorhandler.cpp.

KXErrorHandler::KXErrorHandler | ( | bool(*)(int request, int error_code, unsigned long resource_id) | handler,
|  | Display * | dpy = `qt_xdisplay()`
| ) |

| This constructor takes pointer to a function that will get request number, error code number and resource id of the failed request, as provided by XErrorEvent. If the function returns true, the error flag will be set. Definition at line 47 of file kxerrorhandler.cpp.

KXErrorHandler::KXErrorHandler | ( | int(*)(Display *, XErrorEvent *) | handler,
|  | Display * | dpy = `qt_xdisplay()`
| ) |

| This constructor takes pointer to a function whose prototype matches the one that's used with the XSetErrorHandler() Xlib function. NOTE: For the error flag to be set, the function must return non-zero value. Definition at line 58 of file kxerrorhandler.cpp.

## Member Function Documentation

bool KXErrorHandler::error | ( | bool | sync | ) | const

This function returns true if the error flag is set (i.e.

no custom handler function was used and there was any error, or the custom handler indicated an error by its return value).

Parameters:

  | sync | if true, and explicit XSync() will be done. Not necessary when the last X request required a roundtrip.

Definition at line 86 of file kxerrorhandler.cpp.

Referenced by KSelectionWatcher::owner().

The documentation for this class was generated from the following files:

- kxerrorhandler.h
- kxerrorhandler.cpp

This file is part of the documentation for kdecore Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:19:13 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003